# Webservices (wrap) Handlers Library

## Rust Libraries Collections for webservices ([warp](https://github.com/seanmonstar/warp)) handlers

Part of the following developments:

- [Zteron](https://rlung.librecloud.online/LibreCloud/CloudMandala#cloudmandala)

Includes applications definitions and functions for following areas:

- App auth handlers library: login, admin, member.
- Files Upload.
- Web Request enviroment definition and functions.
- Authentication
- Render templates and pages
- Lang definitions

### Criteria

In a basic application scenario this group or library collections are included together.

Updating packages or dependencies shoud be keep in sync among <u>Cargo.toml</u> declarations.

### How to use

1 - Clone or download this lib in a path, better outside of target development

2 - Get current version from <u>Cargo.toml</u>

3 - <u>For each member of</u>  of **Defs Library** one line like the one below should be included in <u>target development Cargo.toml</u> (adjust version & path) and **use** whatever is need.

```toml
app_auth_filters = { version = "0.1.0", path = "../lib/filters/app_auth_filters" }
```

To include all libraries:

```toml
app_auth_filters = { version = "0.1.0", path = "../lib/filters/app_auth_filters" }
app_file_filters = { version = "0.1.0", path = "../lib/filters/app_file_filters" }
reject_filters = { version = "0.1.0", path = "../lib/filters/reject_filters" }
```

### Structure

Each directory contains a Library dedicated to applications common needs:
Inside of each directory README.md and TODO.md files has more details.

#### app_auth_handlers

App auth handlers library

Handlers for request for auth management using [warp](https://github.com/seanmonstar/warp)

<pre>
app_auth_handlers
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>

#### app_file_handlers

Files uploads.

<pre>
app_file_handlers/
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>

#### reqenv

Web Request enviroment definition and functions

<pre>
reqenv
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>


#### reqtasks

Handlers for: 

- Authentication
- Access: admin, session token.
- Render tamplates and pages
- Lang definitions

<pre>
reqtasks
├── Cargo.toml
├── README.md
├── TODO.md
└── src
    └── lib.rs
</pre>

## Author

- [Jesús Pérez](https://info.jesusperez.pro).

## License

MIT
